# Class VulkanRenderPassCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanRenderPassCreateInfo

All Implemented Interfaces:
  `VulkanRenderPassCreateInfoType`

public final class VulkanRenderPassCreateInfo extends Object implements VulkanRenderPassCreateInfoType
Structure specifying parameters of a newly created render pass.

See Also:
  - "VkRenderPassCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanRenderPassCreateInfo.Builder`
  Builds instances of type `VulkanRenderPassCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<VulkanAttachmentDescription>`
  `attachments()`
  `static VulkanRenderPassCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanRenderPassCreateInfo`.
  `static VulkanRenderPassCreateInfo`
  `copyOf(VulkanRenderPassCreateInfoType instance)`
  Creates an immutable copy of a `VulkanRenderPassCreateInfoType` value.
  `List<VulkanSubpassDependency>`
  `dependencies()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanRenderPassCreateInfo` that have equal attribute values.
  `Set<VulkanRenderPassCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `attachments`, `subpasses`, `dependencies`.
  `static VulkanRenderPassCreateInfo`
  `of(Iterable<VulkanRenderPassCreateFlag> flags, Iterable<? extends VulkanAttachmentDescription> attachments, Iterable<? extends VulkanSubpassDescription> subpasses, Iterable<? extends VulkanSubpassDependency> dependencies)`
  Construct a new immutable `VulkanRenderPassCreateInfo` instance.
  `static VulkanRenderPassCreateInfo`
  `of(Set<VulkanRenderPassCreateFlag> flags, List<VulkanAttachmentDescription> attachments, List<VulkanSubpassDescription> subpasses, List<VulkanSubpassDependency> dependencies)`
  Construct a new immutable `VulkanRenderPassCreateInfo` instance.
  `List<VulkanSubpassDescription>`
  `subpasses()`
  `String`
  `toString()`
  Prints the immutable value `VulkanRenderPassCreateInfo` with attribute values.
  `final VulkanRenderPassCreateInfo`
  `withAttachments(VulkanAttachmentDescription... elements)`
  Copy the current immutable object with elements that replace the content of `attachments`.
  `final VulkanRenderPassCreateInfo`
  `withAttachments(Iterable<? extends VulkanAttachmentDescription> elements)`
  Copy the current immutable object with elements that replace the content of `attachments`.
  `final VulkanRenderPassCreateInfo`
  `withDependencies(VulkanSubpassDependency... elements)`
  Copy the current immutable object with elements that replace the content of `dependencies`.
  `final VulkanRenderPassCreateInfo`
  `withDependencies(Iterable<? extends VulkanSubpassDependency> elements)`
  Copy the current immutable object with elements that replace the content of `dependencies`.
  `final VulkanRenderPassCreateInfo`
  `withFlags(VulkanRenderPassCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanRenderPassCreateInfo`
  `withFlags(Iterable<VulkanRenderPassCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanRenderPassCreateInfo`
  `withSubpasses(VulkanSubpassDescription... elements)`
  Copy the current immutable object with elements that replace the content of `subpasses`.
  `final VulkanRenderPassCreateInfo`
  `withSubpasses(Iterable<? extends VulkanSubpassDescription> elements)`
  Copy the current immutable object with elements that replace the content of `subpasses`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanRenderPassCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanRenderPassCreateInfoType`
    Returns:
      The module creation flags

  - ### attachments

    public List<VulkanAttachmentDescription> attachments()
    Specified by:
      `attachments` in interface `VulkanRenderPassCreateInfoType`
    Returns:
      The render pass attachments

  - ### subpasses

    public List<VulkanSubpassDescription> subpasses()
    Specified by:
      `subpasses` in interface `VulkanRenderPassCreateInfoType`
    Returns:
      The subpasses

  - ### dependencies

    public List<VulkanSubpassDependency> dependencies()
    Specified by:
      `dependencies` in interface `VulkanRenderPassCreateInfoType`
    Returns:
      The subpass dependencies

  - ### withFlags

    public final VulkanRenderPassCreateInfo withFlags(VulkanRenderPassCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanRenderPassCreateInfo withFlags(Iterable<VulkanRenderPassCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withAttachments

    public final VulkanRenderPassCreateInfo withAttachments(VulkanAttachmentDescription... elements)
    Copy the current immutable object with elements that replace the content of `attachments`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withAttachments

    public final VulkanRenderPassCreateInfo withAttachments(Iterable<? extends VulkanAttachmentDescription> elements)
    Copy the current immutable object with elements that replace the content of `attachments`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of attachments elements to set
    Returns:
      A modified copy of `this` object

  - ### withSubpasses

    public final VulkanRenderPassCreateInfo withSubpasses(VulkanSubpassDescription... elements)
    Copy the current immutable object with elements that replace the content of `subpasses`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withSubpasses

    public final VulkanRenderPassCreateInfo withSubpasses(Iterable<? extends VulkanSubpassDescription> elements)
    Copy the current immutable object with elements that replace the content of `subpasses`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of subpasses elements to set
    Returns:
      A modified copy of `this` object

  - ### withDependencies

    public final VulkanRenderPassCreateInfo withDependencies(VulkanSubpassDependency... elements)
    Copy the current immutable object with elements that replace the content of `dependencies`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withDependencies

    public final VulkanRenderPassCreateInfo withDependencies(Iterable<? extends VulkanSubpassDependency> elements)
    Copy the current immutable object with elements that replace the content of `dependencies`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of dependencies elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanRenderPassCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `attachments`, `subpasses`, `dependencies`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanRenderPassCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanRenderPassCreateInfo of(Set<VulkanRenderPassCreateFlag> flags, List<VulkanAttachmentDescription> attachments, List<VulkanSubpassDescription> subpasses, List<VulkanSubpassDependency> dependencies)
    Construct a new immutable `VulkanRenderPassCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `attachments` - The value for the `attachments` attribute
      `subpasses` - The value for the `subpasses` attribute
      `dependencies` - The value for the `dependencies` attribute
    Returns:
      An immutable VulkanRenderPassCreateInfo instance

  - ### of

    public static VulkanRenderPassCreateInfo of(Iterable<VulkanRenderPassCreateFlag> flags, Iterable<? extends VulkanAttachmentDescription> attachments, Iterable<? extends VulkanSubpassDescription> subpasses, Iterable<? extends VulkanSubpassDependency> dependencies)
    Construct a new immutable `VulkanRenderPassCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `attachments` - The value for the `attachments` attribute
      `subpasses` - The value for the `subpasses` attribute
      `dependencies` - The value for the `dependencies` attribute
    Returns:
      An immutable VulkanRenderPassCreateInfo instance

  - ### copyOf

    public static VulkanRenderPassCreateInfo copyOf(VulkanRenderPassCreateInfoType instance)
    Creates an immutable copy of a `VulkanRenderPassCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanRenderPassCreateInfo instance

  - ### builder

    public static VulkanRenderPassCreateInfo.Builder builder()
    Creates a builder for `VulkanRenderPassCreateInfo`.

         VulkanRenderPassCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanRenderPassCreateFlag) // flags elements
            .addAttachments|addAllAttachments(VulkanAttachmentDescription) // attachments elements
            .addSubpasses|addAllSubpasses(VulkanSubpassDescription) // subpasses elements
            .addDependencies|addAllDependencies(VulkanSubpassDependency) // dependencies elements
            .build();

    Returns:
      A new VulkanRenderPassCreateInfo builder